unit Ansi2OEM;         {(c) Alfware Bernd Schubert 24.10.2017}

interface

function Zitadell_Oem2Ansi(s: string): string;

function Zitadell_Ansi2Oem(s: string): string;

implementation

const source: array[0..255] of string[20] = (
   'NR  CHR ANS OEM RIC',
   '001         001    ',
   '002         002    ',
   '003         003    ',
   '004         004    ',
   '005         005    ',
   '006         006    ',
   '007         007    ',
   '008         008    ',
   '009         009    ',
   '010         010    ',
   '011         011    ',
   '012         012    ',
   '013         013    ',
   '014         014    ',
   '015         015    ',
   '016         016    ',
   '017         017    ',
   '018         018    ',
   '019         019    ',
   '020         020    ',
   '021         021    ',
   '022         022    ',
   '023         023    ',
   '024         024    ',
   '025         025    ',
   '026         026    ',
   '027         027    ',
   '028         028    ',
   '029         029    ',
   '030         030    ',
   '031         031    ',
   '032         032    ',
   '033 !       033    ',
   '034 "       034    ',
   '035 #       035    ',
   '036 $       036    ',
   '037 %   128 037 A  ',
   '038 &       038    ',
   '039 ''       039    ',
   '040 (       040    ',
   '041 )       041    ',
   '042 *       042    ',
   '043 +       043    ',
   '044 ,       044    ',
   '045 -       045    ',
   '046 .       046    ',
   '047 /       047    ',
   '048 0       048    ',
   '049 1       049    ',
   '050 2       050    ',
   '051 3       051    ',
   '052 4       052    ',
   '053 5       053    ',
   '054 6       054    ',
   '055 7       055    ',
   '056 8       056    ',
   '057 9       057    ',
   '058 :       058    ',
   '059 ;       059    ',
   '060 <       060    ',
   '061 =       061    ',
   '062 >       062    ',
   '063 ?       063    ',
   '064 @       064    ',
   '065 A       065    ',
   '066 B       066    ',
   '067 C       067    ',
   '068 D       068    ',
   '069 E       069    ',
   '060 F       060    ',
   '071 G       071    ',
   '072 H       072    ',
   '073 I       073    ',
   '074 J       074    ',
   '075 K       075    ',
   '076 L       076    ',
   '077 M       077    ',
   '078 N       078    ',
   '079 O       079    ',
   '080 P       080    ',
   '081 Q       081    ',
   '082 R       082    ',
   '083 S       083    ',
   '084 T       084    ',
   '085 U       085    ',
   '086 V       086    ',
   '087 W       087    ',
   '088 X       088    ',
   '089 Y       089    ',
   '090 Z       090    ',
   '091 [       091    ',
   '092 \       092    ',
   '093 ]       093    ',
   '094 ^       094    ',
   '095 _       095    ',
   '096 `       096    ',
   '097 a       097    ',
   '098 b       098    ',
   '099 c       099    ',
   '100 d       100    ',
   '101 e       101    ',
   '102 f       102    ',
   '103 g       103    ',
   '104 h       104    ',
   '105 i       105    ',
   '106 j       106    ',
   '107 k       107    ',
   '108 l       108    ',
   '109 m       109    ',
   '110 n       110    ',
   '111 o       111    ',
   '112 p       112    ',
   '113 q       113    ',
   '114 r       114    ',
   '115 s       115    ',
   '116 t       116    ',
   '117 u       117    ',
   '118 v       118    ',
   '119 w       119    ',
   '120 x       120    ',
   '121 y       121    ',
   '122 z       122    ',
   '123 {       123    ',
   '124 |       124    ',
   '125 }       125    ',
   '126 ~       126    ',
   '127        127    ',
   '128    199 128 B  ',
   '129    252 129 B  ',
   '130    233 130 B  ',
   '131    226 131 B  ',
   '132    228 132 B  ',
   '133    224 133 B  ',
   '134    229 134 B  ',
   '135    231 135 B  ',
   '136    234 136 B  ',
   '137    235 137 B  ',
   '138    232 138 B  ',
   '139    239 139 B  ',
   '140    238 140 B  ',
   '141    236 141 B  ',
   '142    196 142 B  ',
   '143    197 143 B  ',
   '144    201 144 B  ',
   '145    230 145 B  ',
   '146    198 146 B  ',
   '147    244 147 B  ',
   '148    246 148 B  ',
   '149    242 149 B  ',
   '150    251 150 B  ',
   '151    249 151 B  ',
   '152    255 152 B  ',
   '153    214 153 B  ',
   '154    220 154 B  ',
   '155    248 155 B  ',
   '156    163 156 B  ',
   '157    216 157 B  ',
   '158    215 158 B  ',
   '159    131 159 B  ',
   '160    225 160 B  ',
   '161    237 161 B  ',
   '162    243 162 B  ',
   '163    250 163 B  ',
   '164    241 164 B  ',
   '165    209 165 B  ',
   '166        166    ',
   '167    248 167 B  ',
   '168    191 168 B  ',
   '169    174 169 B  ',
   '170        170    ',
   '171    189 171 B  ',
   '172    188 172 B  ',
   '173    161 173 B  ',
   '174    171 174 B  ',
   '175    187 175 B  ',
   '176        176    ',
   '177        177    ',
   '178        178    ',
   '179        179    ',
   '180        180    ',
   '181    193 181 B  ',
   '182    194 182 B  ',
   '183    192 183 B  ',
   '184    169 184 B  ',
   '185        185    ',
   '186        186    ',
   '187        187    ',
   '188        188    ',
   '189    162 189 B  ',
   '190    165 190 B  ',
   '191        191    ',
   '192        192    ',
   '193        193    ',
   '194        194    ',
   '195        195    ',
   '196        196    ',
   '197        197    ',
   '198    227 198 B  ',
   '199    195 199 B  ',
   '200        200    ',
   '201        201    ',
   '202        202    ',
   '203        203    ',
   '204        204    ',
   '205        205    ',
   '206        206    ',
   '207        207    ',
   '208        208    ',
   '209        209    ',
   '210    202 210 B  ',
   '211    203 211 B  ',
   '212    200 212 B  ',
   '213        213    ',
   '214    205 214 B  ',
   '215    206 215 B  ',
   '216    207 216 B  ',
   '217        217    ',
   '218        218    ',
   '219        219    ',
   '220        220    ',
   '221        221    ',
   '222        222    ',
   '223        223    ',
   '224    211 224 B  ',
   '225    223 225 B  ',
   '226    212 226 B  ',
   '227    210 227 B  ',
   '228    245 228 B  ',
   '229    213 229 B  ',
   '230    181 230 B  ',
   '231        231    ',
   '232        232    ',
   '233    218 233 B  ',
   '234    219 234 B  ',
   '235    217 235 B  ',
   '236    253 236 B  ',
   '237    221 237 B  ',
   '238        238    ',
   '239        239    ',
   '240        240    ',
   '241    177 241 B  ',
   '242        242    ',
   '243    190 243 B  ',
   '244    182 244 B  ',
   '245    162 245 B  ',
   '246    247 246 B  ',
   '247        247    ',
   '248    164 248 B  ',
   '249        249    ',
   '250        250    ',
   '251    185 251 B  ',
   '252    178 252 B  ',
   '253    179 253 B  ',
   '254        254    ',
   '255        255    ');

var  oem, ansi: array[1..255] of integer;

procedure analyse;
var i: integer; w: word;
    {nr,} oem1, ansi1: integer;
    {zeichen,} richtung: char;
    s: string;
begin
   for i:=1 to 255 do begin
      oem[i]:=0; ansi[i]:=0;
   end;
   for i:=1 to 255 do begin
      s:=source[i];
      {val (copy(s, 1, 3), nr, w);}
      val (copy(s, 9, 3), ansi1, w);
      val (copy(s, 13, 3), oem1, w);
      richtung:=s[17];
      {zeichen:=s[5];}
      if richtung in ['B','A'] then oem[oem1]:=ansi1;
      if richtung in ['B','O'] then ansi[ansi1]:=oem1;
   end;
end;

function char_oem2ansi(c: char): char;
var n,u : integer;
begin
   n:=ord(c); u:=oem[n];
   if u > 0
      then char_oem2ansi:=chr(u)
      else char_oem2ansi:=c;
end;

function char_ansi2oem(c: char): char;
var n,u : integer;
begin
   n:=ord(c); u:=ansi[n];
   if u > 0
      then char_ansi2oem:=chr(u)
      else char_ansi2oem:=c;
end;

function Zitadell_Oem2Ansi(s: string): string;
var i: integer; c: char; temp: string;
begin
   temp:='';
   for i:=1 to Length(s) do begin
      c:=s[i]; temp:=temp + char_oem2ansi(c);
   end;
   Zitadell_Oem2Ansi:=temp;
end;

function Zitadell_Ansi2Oem(s: string): string;
var i: integer; c: char; temp: string;
begin
   temp:='';
   for i:=1 to Length(s) do begin
      c:=s[i]; temp:=temp + char_ansi2oem(c);
   end;
   Zitadell_Ansi2Oem:=temp;
end;

begin
   Analyse;
end.
