UNIT Code95;   {(c) ALFWARE Bernd Schubert V:4.67 23.10.2017}

INTERFACE

CONST codealf=CHR($00)+CHR($11)+CHR($22)+CHR($33)+CHR($44)+CHR($55)+CHR($66)+
              CHR($77)+CHR($88)+CHR($99)+CHR($AA)+CHR($BB)+CHR($CC)+CHR($DD)+
              CHR($EE)+CHR($FF)+'(c) ALFWARE B.Schubert';

{$IFNDEF WinZitat}

      filename:STRING='TEST'; buffsize=32768;

VAR buffer:ARRAY[1..buffsize] OF BYTE;
    CodeGefunden,CodeReadOnly:BOOLEAN;

FUNCTION CodeOpen(datei:STRING; func:BYTE):INTEGER;
FUNCTION CodeClose(func:BYTE):INTEGER;
FUNCTION CodeReadEOF:BOOLEAN;
FUNCTION CodeWriteEOF:BOOLEAN;
FUNCTION CodeRead:WORD;
FUNCTION CodeWrite:WORD;
PROCEDURE CodeRename;
FUNCTION CodeFind(fs:WORD; status:STRING):WORD;
PROCEDURE Buffer2String(von,bis:WORD; VAR st:STRING);
PROCEDURE String2Buffer(st:STRING; von,bis:WORD);

{$ENDIF}

IMPLEMENTATION

{$IFNDEF WinZitat}

USES DOS;

VAR esize,asize:WORD; efile,afile:FILE;

FUNCTION CodeOpen(datei:STRING; func:BYTE):INTEGER;
VAR IO:INTEGER;
BEGIN
   filename:=datei; IO:=0;
   IF func IN [0,1] THEN BEGIN
      Assign(efile,datei+'.exe'); {$I-} Reset(efile,1); {$I+} IO:=IOResult;
   END;
   IF (IO=0) AND (func IN [0,2]) AND (NOT CodeReadOnly) THEN BEGIN
      Assign(afile,datei+'.tmp'); {$I-} Rewrite(afile,1); {$I+} IO:=IOResult;
   END;
   CodeOpen:=IO;
END;

FUNCTION CodeClose(func:BYTE):INTEGER;
VAR IO:INTEGER;
BEGIN
   IF func IN [0,1] THEN BEGIN
      {$I-} Close(efile); {$I+} IO:=IOResult;
   END;
   IF (IO=0) AND (func IN [0,2]) AND (NOT CodeReadOnly) THEN BEGIN
      {$I-} Close(afile); {$I+} IO:=IOResult;
   END;
   CodeClose:=IO;
END;

FUNCTION CodeRead:WORD;
BEGIN
   BlockRead(efile,buffer,buffsize,esize); CodeRead:=esize;
END;

FUNCTION CodeWrite:WORD;
BEGIN
   asize:=0;
   IF NOT CodeReadonly THEN BlockWrite(afile,buffer,esize,asize);
   CodeWrite:=asize;
END;

FUNCTION CodeReadEOF:BOOLEAN;
BEGIN
   CodeReadEOF:=(esize=0);
END;

FUNCTION CodeWriteEOF:BOOLEAN;
BEGIN
   CodeWriteEOF:=CodeReadOnly OR (esize=0) OR (esize<>asize);
END;

PROCEDURE CodeRename;
VAR tfile:FILE;
BEGIN
   IF NOT CodeReadOnly THEN BEGIN
      Assign(tfile,filename+'.bak');
      {$I-}Reset(tfile);{$I+}
      IF IOResult=0 THEN BEGIN Close(tfile); Erase(tfile) END;
      Rename(efile,filename+'.bak'); Rename(afile,filename+'.exe');
   END;
END;

PROCEDURE Buffer2String(von,bis:WORD; VAR st:STRING);
VAR d:WORD;
BEGIN
   st:=''; FOR d:=von TO bis DO st:=st+CHR(buffer[d]);
END;

PROCEDURE String2Buffer(st:STRING; von,bis:WORD);
VAR d:WORD;
BEGIN
   FOR d:=von TO bis DO buffer[d]:=ORD(st[d-von+1]);
END;

FUNCTION CodeFind(fs:WORD; status:STRING):WORD;
VAR s:STRING; d,kk:WORD;
BEGIN
   s:=''; FOR d:=1 TO LENGTH(status) DO s:=s+' '; kk:=0;
   REPEAT
      s:=COPY(s+CHR(buffer[kk+1]),2,LENGTH(status)); INC(kk);
   UNTIL (kk>=fs) or (s=status);
   IF kk>=fs THEN CodeFind:=0 ELSE CodeFind:=kk+1;
   CodeGefunden:=(s=status);
END;

{$ENDIF}

BEGIN
   {$IFNDEF WinZitat}
   CodeGefunden:=FALSE; CodeReadOnly:=FALSE;
   {$ENDIF}
END.
