unit spruch_anz_label;

{$mode objfpc}{$H+}
{$I winzitat_ver.inc}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Zitate_Server;

type

  { TForm2L }

  TForm2L = class(TForm)
     Button1: TButton;
     Label1: TLabel;
     Label2: TLabel;
     Label3: TLabel;
     Timer1: TTimer;
     procedure Button1Click(Sender: TObject);
     procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
     procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
     procedure FormResize(Sender: TObject);
     procedure FormShow(Sender: TObject);
     procedure SpruchAnzeige(Sender: TObject);
     procedure SetzeLabel(Sender: TObject);
     procedure Umschalten(Sender: TObject);
     procedure AnzeigeCountdown(Sender: TObject);
     procedure Timer1Timer(Sender: TObject);
  private
     aktuell, countdown: integer;
     stop, einmal: boolean;
  public
     datei, nummer: integer;
     spruch: string;
  end;

var
   Form2L: TForm2L;

implementation

{$R *.lfm}

{ TForm2L }

procedure TForm2L.Button1Click(Sender: TObject);
begin
   Umschalten(Sender);
end;

procedure TForm2L.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
    Timer1.Enabled:=false;
end;

procedure TForm2L.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   if Key = 27
      then Close
      else begin Umschalten(Sender); Key:=0; end;
end;

procedure TForm2L.Umschalten(Sender: TObject);
begin
   stop:= not stop;
   if stop then Button1.Caption:='Weiter' else Button1.Caption:='Halt';
end;

procedure TForm2L.FormResize(Sender: TObject);
begin
   if Form2L.Width < 400 then Form2L.Width := 400;
   if Form2L.Height < Label2.Height + (Button1.Height + {$IFDEF Linux} 55 {$ELSE} 33 {$ENDIF} )
      then Form2L.Height := Label2.Height + (Button1.Height + {$IFDEF Linux} 55 {$ELSE} 33 {$ENDIF} );
   SetzeLabel(Sender);
end;

procedure TForm2L.FormShow(Sender: TObject);
begin
   with Zitadell do begin
      countdown:=dauer; einmal:=true; aktuell:=1;
      AnzeigeCountdown(Sender);
      stop:= false; Button1.Caption:='Halt';
      SpruchAnzeige(Sender);
      Timer1.Interval := 1000;
      Timer1.Enabled := True;
   end;
end;

procedure TForm2L.Timer1Timer(Sender: TObject);
begin
   if stop then exit;
   with Zitadell do begin
      if einmal then AnzeigeCountdown(Sender);
      dec(countdown); einmal:=false;
      if countdown = 0 then begin
         if aktuell < anzahl then begin
            Hole_Spruch(true);
            datei:=datei_akt;  nummer:=spruch_akt; spruch:=spruch_text;
            SpruchAnzeige(Sender);
         end;
         inc(aktuell); countdown:=dauer;
      end;
      if aktuell <= anzahl
         then AnzeigeCountdown(Sender)
         else begin
            Timer1.Enabled:=False;
            Close;
      end;
   end;
end;

procedure TForm2L.SpruchAnzeige(Sender: TObject);
begin
   with Zitadell do begin
      Label1.Caption:= Str0(datei, 3) + ' # '+ Str0(nummer, 3);
      Label2.Font.Height:={$IFDEF Linux} 16 {$ELSE} 27 {$ENDIF};
      Label2.Caption:= spruch;
      Form2L.Width := Label2.Width + 66;
      if Form2L.Width < 400 then Form2L.Width := 400;
      Form2L.Height := Label2.Height + Button1.Height + {$IFDEF Linux} 72 {$ELSE} 50 {$ENDIF};
      SetzeLabel(Sender);
   end;
end;

procedure TForm2L.SetzeLabel(Sender: TObject);
begin
   Button1.Top := Form2L.Height - (Button1.Height + 25);
   Button1.Left:= Form2L.Width div 2 - Button1.Width div 2;
   Label1.Top := Form2L.Height - (Button1.Height + 25);
   Label1.Left := Form2L.Width - (Label1.Width + 50);
   Label3.Top := Form2L.Height - (Button1.Height + 25);
   Label3.Left := 50;
end;

procedure TForm2L.AnzeigeCountdown(Sender: TObject);
begin
   with Zitadell do Label3.Caption:= Str0(aktuell, 2) + '/' + Str0(anzahl, 2)
                                     + ' # ' + Str0(countdown, 2);
end;

end.
