unit spruch_anz_memo;

{$mode objfpc}{$H+}
{$I winzitat_ver.inc}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Zitate_Server;

type

  { TForm2M }

  TForm2M = class(TForm)
     Button1: TButton;
     Label1: TLabel;
     Label3: TLabel;
     Memo1: TMemo;
     Timer1: TTimer;
     procedure Button1Click(Sender: TObject);
     procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
     procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
     procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
     procedure FormResize(Sender: TObject);
     procedure FormShow(Sender: TObject);
     procedure SpruchAnzeige(Sender: TObject);
     procedure SetzeLabel(Sender: TObject);
     procedure Umschalten(Sender: TObject);
     procedure AnzeigeCountdown(Sender: TObject);
     procedure Timer1Timer(Sender: TObject);
  private
     aktuell, countdown: integer;
     stop, einmal: boolean;
  public
     datei, nummer: integer;
     spruch: string;
  end;

var
   Form2M: TForm2M;

implementation

{$R *.lfm}

{ TForm2M }

procedure TForm2M.Button1Click(Sender: TObject);
begin
   Umschalten(Sender);
end;

procedure TForm2M.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
   Timer1.Enabled:=false;
end;

procedure TForm2M.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   if Key = 27
      then Close
      else begin Umschalten(Sender); Key:=0; end;
end;

procedure TForm2M.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   if (ssCtrl in Shift) and (Key = Ord('C')) then Memo1.CopyToClipboard;
end;

procedure TForm2M.Umschalten(Sender: TObject);
begin
   stop:= not stop;
   if stop then Button1.Caption:='Weiter' else Button1.Caption:='Halt';
end;

procedure TForm2M.FormResize(Sender: TObject);
begin
   if Form2M.Width < 400 then Form2M.Width := 400;
   if Form2M.Height < Memo1.Height + (Button1.Height + 63)
      then Form2M.Height := Memo1.Height + (Button1.Height + 63);
   Memo1.Width:=Form2m.Width - 50;
   SetzeLabel(Sender);
end;

procedure TForm2M.FormShow(Sender: TObject);
begin
   with Zitadell do begin
      countdown:=dauer; einmal:=true; aktuell:=1;
      AnzeigeCountdown(Sender);
      stop:= false; Button1.Caption:='Halt';
      SpruchAnzeige(Sender);
      Timer1.Interval := 1000;
      Timer1.Enabled := True;
   end;
end;

procedure TForm2M.Timer1Timer(Sender: TObject);
begin
   if stop then exit;
   with Zitadell do begin
      if einmal then AnzeigeCountdown(Sender);
      dec(countdown); einmal:=false;
      if countdown = 0 then begin
         if aktuell < anzahl then begin
            Hole_Spruch(true);
            datei:=datei_akt;  nummer:=spruch_akt; spruch:=spruch_text;
            SpruchAnzeige(Sender);
         end;
         inc(aktuell); countdown:=dauer;
      end;
      if aktuell <= anzahl
         then AnzeigeCountdown(Sender)
         else begin
            Timer1.Enabled:=False;
            Close;
      end;
   end;
end;

procedure TForm2M.SpruchAnzeige(Sender: TObject);
begin
   with Zitadell do begin
      Label1.Caption:=Str0(datei, 3) + ' # ' + Str0(nummer, 3);
      {$IFDEF Linux} Memo1.font.Height:=16; {$ENDIF}
      Memo1.text:=spruch;
      SetzeLabel(Sender);
   end;
end;

procedure TForm2M.SetzeLabel(Sender: TObject);
begin
   Button1.Top := Form2M.Height - (Button1.Height + 25);
   Button1.Left:= Form2M.Width div 2 - Button1.Width div 2;
   Label1.Top := Form2M.Height - (Button1.Height + 25);
   Label1.Left := Form2M.Width - (Label1.Width + 50);
   Label3.Top := Form2M.Height - (Button1.Height + 25);
   Label3.Left := 50;
end;

procedure TForm2M.AnzeigeCountdown(Sender: TObject);
begin
   with Zitadell do Label3.Caption:= Str0(aktuell, 2) + '/' + Str0(anzahl, 2)
                                     + ' # ' + Str0(countdown, 2);
end;

end.
