unit winzitat_main;

{$mode objfpc}{$H+}
{$I winzitat_ver.inc}

interface

uses
   Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
   Code95, Zitate_Server
   {$IFDEF ZitadellSpruchLabel} , Spruch_Anz_Label {$ENDIF}
   {$IFDEF ZitadellSpruchMemo}  , Spruch_Anz_Memo  {$ENDIF} ;

const
   alfstatus = CodeAlf + ' - VON=<037> BIS=<045>';
   pos1 = LENGTH(CodeAlf) + 9;
   cright = 'Zitadell Version 4.72 ansi/oem test' + slinebreak + '(c) ALFWARE  B.Schubert' +
            slinebreak + slinebreak + 'Ursprünglich 2001 erstellt für Windows/16bit und Borland Pascal' +
            slinebreak + 'Portiert 2017 mit Lazarus für Linux Mint und Windows 7/32bit' +
            slinebreak + slinebreak + 'Weitere Pläne: Umstellen von Datei auf SQLite,' +
            slinebreak + 'automatische Anzeige wie bei Android und/oder Java-Zitadell';

type
   { TForm1 }

   TForm1 = class(TForm)
      MainMenu1: TMainMenu;
      miDateiEingeben: TMenuItem;
      miAbfolgeBeidesLetztes: TMenuItem;
      miDateiZufall: TMenuItem;
      miDateiLetztes: TMenuItem;
      miSpruchEingeben: TMenuItem;
      miSpruchZufall: TMenuItem;
      miSpruchLetztes: TMenuItem;
      miAbfolgeVor: TMenuItem;
      miAbfolgeZurueck: TMenuItem;
      miAbfolgeBeideZufall: TMenuItem;
      miParaAnzeigen: TMenuItem;
      miParaDatei: TMenuItem;
      miParaSpruch: TMenuItem;
      miParaBeides: TMenuItem;
      miZeigen: TMenuItem;
      miNochmal: TMenuItem;
      mIParameter: TMenuItem;
      miAutor: TMenuItem;
      miEnde: TMenuItem;
      procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
      procedure miAbfolgeBeidesLetztesClick(Sender: TObject);
      procedure miAbfolgeBeideZufallClick(Sender: TObject);
      procedure miAbfolgeVorClick(Sender: TObject);
      procedure miAbfolgeZurueckClick(Sender: TObject);
      procedure miAutorClick(Sender: TObject);
      procedure miDateiEingebenClick(Sender: TObject);
      procedure miDateiLetztesClick(Sender: TObject);
      procedure miDateiZufallClick(Sender: TObject);
      procedure miEndeClick(Sender: TObject);
      procedure miNochmalClick(Sender: TObject);
      procedure miParaAnzeigenClick(Sender: TObject);
      procedure miSpruchEingebenClick(Sender: TObject);
      procedure miSpruchLetztesClick(Sender: TObject);
      procedure miSpruchZufallClick(Sender: TObject);
      procedure miZeigenClick(Sender: TObject);
      procedure myCreate(Sender: TObject);
  private
     { private declarations }
  public
     { public declarations }
  end;

var
   Form1: TForm1;

implementation

{$R *.lfm}

{ Hilfe }

function MessageDlgTitle(const Title: String; const Msg: string; Buttons: TMsgDlgButtons; HelpCtx: Longint): Integer;
begin
   with CreateMessageDialog(Msg, mtCustom, Buttons) do
   try
      Caption:=Title;
      HelpContext:=HelpCtx;
      HelpFile:='';
      Position:=poScreenCenter;
      result:=ShowModal;
   finally
      Free;
   end;
end;

procedure Nachricht(text: string);
begin
   case MessageDlg(text, mtInformation, [mbOK], 0) of
     mrOK, mrCancel:   ;
     else              MessageDlg('Fehler?', mtError, [], 0);
  end;
end;

procedure Nachricht2(titel, text: string);
begin
  case MessageDlgTitle(titel, text, [mbOK], 0) of
     mrOK, mrCancel:   ;
     else              MessageDlg('Fehler?', mtError, [], 0);
  end;
end;

{ TForm2 aufrufen }

procedure Spruch_Form(spruch_text: string; datei_akt, spruch_akt: longint);
begin
   {$IFDEF ZitadellSpruchMemo}
     Form2M.spruch:=spruch_text;
     Form2M.datei:=datei_akt;
     Form2M.nummer:=spruch_akt;
     Form2M.ShowModal;
   {$ENDIF}
   {$IFDEF ZitadellSpruchLabel}
     Form2L.spruch:=spruch_text;
     Form2L.datei:=datei_akt;
     Form2L.nummer:=spruch_akt;
     Form2L.ShowModal;
   {$ENDIF}
   {$IFDEF ZitadellSpruchBox}
     Nachricht2('Spruch',spruch_text);
   {$ENDIF}
end;

{ TForm1 }

procedure TForm1.myCreate(Sender: TObject);
var w: word; temp: integer;
begin
   with Zitadell do begin
      VAL( COPY(alfstatus, pos1 , 3), temp , w);
      if w = 0 then datei_min:=temp else datei_min:=1;
      VAL( COPY(alfstatus, pos1 + 10, 3), temp, w);
      if w = 0 then datei_max:=temp else datei_max:=1 ;
      Hole_Spruch(false);
   end;
end;

procedure TForm1.miZeigenClick(Sender: TObject);
begin
   with Zitadell do begin
      Hole_Spruch(true);
      Spruch_Form(spruch_text, datei_akt, spruch_akt);
   end;
end;

procedure TForm1.miNochmalClick(Sender: TObject);
begin
   with Zitadell do begin
      if fio then Spruch_Form(spruch_text, datei_akt, spruch_akt);
   end;
end;

procedure TForm1.miParaAnzeigenClick(Sender: TObject);
begin
   Nachricht(Zitadell.Parameter_Info);
end;

procedure TForm1.miSpruchEingebenClick(Sender: TObject);
begin
   Zitadell.SpruchEingeben;
end;

procedure TForm1.miSpruchLetztesClick(Sender: TObject);
begin
   Zitadell.SpruchLetztes;
end;

procedure TForm1.miSpruchZufallClick(Sender: TObject);
begin
   Zitadell.SpruchZufall;
end;

procedure TForm1.miAutorClick(Sender: TObject);
begin
   Nachricht2('Autor', cright);
end;

procedure TForm1.miAbfolgeVorClick(Sender: TObject);
begin
   Zitadell.AbfolgeVor;
end;

procedure TForm1.miAbfolgeZurueckClick(Sender: TObject);
begin
   Zitadell.AbfolgeZurueck;
end;

procedure TForm1.miAbfolgeBeideZufallClick(Sender: TObject);
begin
   Zitadell.AbfolgeBeideZufall;
end;

procedure TForm1.miAbfolgeBeidesLetztesClick(Sender: TObject);
begin
   Zitadell.AbfolgeBeidesLetztes;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  case MessageDlg('Programm beenden?', mtWarning, [mbno, mbyes], 0, mbno) of
     mrYes:           ;
     mrNo, mrCancel:  CloseAction:= caNone;
     else             MessageDlg('Fehler?', mtError, [], 0);
  end;

end;

procedure TForm1.miDateiEingebenClick(Sender: TObject);
begin
   Zitadell.DateiEingeben;
end;

procedure TForm1.miDateiLetztesClick(Sender: TObject);
begin
   Zitadell.DateiLetztes;
end;

procedure TForm1.miDateiZufallClick(Sender: TObject);
begin
   Zitadell.DateiZufall;
end;

procedure TForm1.miEndeClick(Sender: TObject);
begin
   Close;
end;

end.
